  10 REM ***********************
  20 REM * 3D Rotator Program  *
  30 REM *  by Richard Taylor  *
  40 REM *      July 1984      *
  50 REM ***********************
  60 REM *      auto-demo      *

  70 BORDER 0: PAPER 0: INK 7
  80 CLEAR 58051: LOAD "" CODE
  90 CLS: GO SUB 9000: REM Initialise

  92 INPUT "Select Object (1-4) ";obj: LET obj=ABS INT obj:
     IF obj<1 OR obj>4 THEN GO TO 92
  93 RESTORE 9000+100*obj

 100 GO SUB 1000: REM Rotate object
 102 IF obj>0 THEN READ a$: IF a$="$" THEN LET obj=-obj
 110 IF a$="d" OR a$="D" THEN GO SUB 2000
 120 IF a$="m" OR a$="M" THEN GO SUB 3000
 130 IF a$="c" OR a$="C" THEN GO SUB 4000
 140 IF a$="s" OR a$="S" THEN GO SUB 5000
 150 IF a$="l" OR a$="L" THEN GO SUB 6000
 160 IF a$="e" OR a$="E" THEN GO TO 90
 170 IF a$="p" OR a$="P" THEN GO SUB 7000
 180 IF a$="t" OR a$="T" THEN GO SUB 8000
 190 IF a$="q" OR a$="Q" THEN COPY
 200 GO TO 100

1000 REM Rotate Object
1010 IF o$<>"" THEN RANDOMIZE USR 58084
1020 LET a$=INKEY$
1030 IF a$>="1" AND a$<="9" THEN
       LET step=VAL a$: BEEP .1,30: GO TO 1010
1040 IF a$="x" THEN LET a=step: GO TO 1700
1050 IF a$="X" THEN LET a=-step: GO TO 1700
1060 IF a$="y" THEN LET a=step: GO TO 1800
1070 IF a$="Y" THEN LET a=-step: GO TO 1800
1080 IF a$="z" THEN LET a=step: GO TO 1900
1090 IF a$="Z" THEN LET a=-step: GO TO 1900
1100 RETURN

1700 POKE 58052,PEEK 58052+a
1710 LET b=PEEK 58052: IF b<180 THEN GO TO 1010
1720 IF SGN a=-1 THEN POKE 58052,b-76
1730 IF SGN a=+1 THEN POKE 58052,b-180
1740 GO TO 1010

1800 POKE 58053,PEEK 58053+a
1810 LET b=PEEK 58053: IF b<180 THEN GO TO 1010
1820 IF SGN a=-1 THEN POKE 58053,b-76
1830 IF SGN a=+1 THEN POKE 58053,b-180
1840 GO TO 1010

1900 POKE 58054,PEEK 58054+a
1910 LET b=PEEK 58054: IF b<180 THEN GO TO 1010
1920 IF SGN a=-1 THEN POKE 58054,b-76
1930 IF SGN a=+1 THEN POKE 58054,b-180
1940 GO TO 1010

2000 REM Delete last line
2010 IF o$="" THEN RETURN
2020 LET o$=o$(TO LEN o$-4)
2030 BEEP .1,30: RETURN

3000 REM Magnify/diminish object
3010 INPUT "Magnify or Diminish? (M/D) "; LINE b$
3020 IF LEN b$<>1 THEN GO TO 3010
3030 IF b$="d" OR b$="D" THEN GO TO 3010
3040 IF b$<>"m" AND b$<>"M" THEN GO TO 3010
3050 INPUT "Magnification Factor? ";a
3060 IF a<1 THEN GO TO 3050
3070 GO TO 3500

3100 INPUT "Diminishing factor? ";a
3110 IF a<1 THEN GO TO 3100
3120 LET a=1/a

3500 INPUT INKEY$:
     PRINT #0; FLASH 1;"          PLEASE WAIT           "
3510 IF o$="" THEN INPUT INKEY$: RETURN
3520 LET d$=o$: FOR d=2 TO LEN d$ STEP 4
3530 FOR e=0 TO 2
3540 LET b=CODE o$(d+e)
3550 IF b<128 THEN
       LET b=b*a: IF b>127 THEN GO TO 3800
3560 IF b>127 THEN
       LET b=b-256: LET b=b*a: LET b=b+256:
       IF b>255 OR b<128 THEN GO TO 3800
3570 LET o$(d+e)=CHR$ b: NEXT e: NEXT d
3580 INPUT INKEY$
3590 LET d$="": RETURN

3800 INPUT INKEY$: BEEP 1,-30: LET o$=d$: LET d$="": RETURN

4000 REM Change colours
4010 INPUT "New BORDER colour? (0-7) ";a
4020 IF a<0 OR a>7 THEN GO TO 4010
4030 INPUT "New PAPER colour? (0-7) ";b
4040 IF b<0 OR b>7 THEN GO TO 4030
4050 INPUT "New INK colour? (0-7) ";c
4060 IF c<0 OR c>7 THEN GO TO 4050
4070 BORDER a: PAPER b: INK c
4080 CLS: RETURN

5000 REM Save to Microdrive/Tape
5010 INPUT "SAVE to Microdrive or Tape?     (M/T) ";LINE b$
5020 IF b$="" THEN GO TO 5010
5030 IF b$="m" OR b$="M" THEN GO TO 5500
5040 IF b$<>"t" AND b$<>"T" THEN GO TO 5010
5050 GO SUB 5800: REM Get name
5060 DIM x$(LEN o$): LET x$=o$: SAVE c$ DATA x$()
5070 GO SUB 5900
5080 IF b$="n" OR b$="N" THEN RETURN
5090 IF b$<>"y" AND b$<>"Y" THEN GO TO 5070
5100 VERIFY c$ DATA x$(): RETURN

5500 GO SUB 5800
5510 INPUT "Which drive? (1-8) ";LINE B$
5520 IF LEN b$<>1 THEN GO TO 5510
5530 IF b$<"1" OR b$>"8" THEN GO TO 5510
5540 REM OPEN #4;"m";VAL b$;c$
5550 PRINT #4;o$
5560 CLOSE #4
5570 RETURN

5800 INPUT  "Filename? "; LINE c$
5810 IF c$="" OR LEN c$>10 THEN GO TO 5800
5820 RETURN

5900 INPUT "Do you wish to Verify? "; LINE b$
5910 IF LEN b$<>1 THEN GO TO 5900
5920 RETURN

6000 REM Load from Drive/Tape
6010 INPUT "LOAD from Microdrive or Tape?   (M/T) "; LINE b$
6020 IF LEN b$<>1 THEN GO TO 6010
6030 IF b$="m" OR b$="M" THEN GO TO 6500
6040 IF b$<>"t" AND b$<>"T" THEN GO TO 6010
6050 INPUT "Filename? (ENTER for first file) "; LINE c$
6060 IF LEN c$>10 THEN GO TO 6050
6070 LOAD c$ DATA x$(): LET o$=x$
6080 RETURN

6500 INPUT "Which drive? (1-8) "; LINE b$
6510 IF LEN b$<>1 OR b$<"1" OR b$>"8" THEN GO TO 6500
6520 GO SUB 5800
6530 REM OPEN #4;"m";VAL b$;c$
6540 INPUT #4;o$
6550 CLOSE #4
6560 RETURN

7000 REM Add a new point
7010 GO SUB 7500
7020 LET o$=o$+CHR$ 0+e$
7030 RETURN

7500 READ a: REM INPUT "X displacement? ";a
7510 IF a<-128 OR a>127 OR a<>INT a THEN GO TO 7500
7520 IF SGN a=-1 THEN LET a=a+256
7530 READ b: REM INPUT "Y displacement? ";b
7540 IF b<-128 OR b>127 OR b<>INT b THEN GO TO 7530
7550 IF SGN b=-1 THEN LET b=b+256
7560 READ c: REM INPUT "Z displacement? ";c
7570 IF c<-128 OR c>127 OR c<>INT c THEN GO TO 7560
7580 IF SGN c=-1 THEN LET c=c+256
7590 LET e$=CHR$ a+CHR$ b+CHR$ c
7600 RETURN

8000 REM Add new line
8010 IF o$="" THEN GO TO 7000
8020 GO SUB 7500: LET o$=o$+CHR$ 1+e$
8030 RETURN

9000 REM Initialise
9010 LET o$=""
9020 LET step=3
9030 POKE 58052,0
9040 POKE 58053,0
9050 POKE 58054,0
9060 RETURN

9100 DATA
"P",-40,  0, 40 , "T", 40,  0, 40 , "T", 40,  0,-40 , "T",-40,  0,-40 ,
"T",-40,  0, 40 , "$"

9200 DATA
"P", 40,-40,-40 , "T",-40,-40,-40 , "T",-40, 40,-40 , "T", 40, 40,-40 ,
"T", 40,-40,-40 , "T", 40,-40, 40 , "T",-40,-40, 40 , "T",-40, 40, 40 ,
"T", 40, 40, 40 , "T", 40,-40, 40 , "P",-40,-40,-40 , "T",-40,-40, 40 ,
"P",-40, 40,-40 , "T",-40, 40, 40 , "P", 40, 40,-40 , "T", 40, 40, 40 , "$"

9300 DATA
"P",-30,  0,-30 , "T", 30,  0,-30 , "T", 30,  0, 30 , "T",-30,  0, 30 ,
"T",-30,  0,-30 , "T",  0, 50,  0 , "T", 30,  0, 30 , "T",  0,-50,  0 ,
"T",-30,  0,-30 , "P", 30,  0,-30 , "T",  0, 50,  0 , "T",-30,  0, 30 ,
"T",  0,-50,  0 , "T", 30,  0,-30 , "$"

9400 DATA
"P",  5, -5,-10 , "T", 40, -5,-10 , "T", 40,  5,-10 , "T",  5,  5,-10 ,
"T",  5,  5, 10 , "T", 40,  5, 10 , "T", 40, -5, 10 , "T",  5, -5, 10 ,
"P", 40,  5, 10 , "T", 40,  5,-10 , "P", 40, -5, 10 , "T", 40, -5,-10 ,
"P",  5,  5,-10 , "T",  5, 40,-10 , "T", -5, 40,-10 , "T", -5,  5,-10
9401 DATA
"T", -5,  5, 10 , "T", -5, 40, 10 , "T",  5, 40, 10 , "T",  5,  5, 10 ,
"P", -5, 40, 10 , "T", -5, 40,-10 , "P",  5, 40, 10 , "T",  5, 40,-10 ,
"P", -5,  5,-10 , "T",-40,  5,-10 , "T",-40, -5,-10 , "T", -5, -5,-10 ,
"T", -5, -5, 10 , "T",-40, -5, 10 , "T",-40,  5, 10 , "T", -5,  5, 10
9402 DATA
"P",-40, -5, 10 , "T",-40, -5,-10 , "P",-40,  5, 10 , "T",-40,  5,-10 ,
"P", -5, -5,-10 , "T", -5,-40,-10 , "T",  5,-40,-10 , "T",  5, -5,-10 ,
"T",  5, -5, 10 , "T",  5,-40, 10 , "T", -5,-40, 10 , "T", -5, -5, 10 ,
"P",  5,-40, 10 , "T",  5,-40,-10 , "P", -5,-40, 10 , "T", -5,-40,-10 , "$"